
# -*- coding: utf-8 -*-

'''
Created on 2016年3月17日
@author:Cheng Jing
'''

# import modules
import ogr, os, sys, psycopg2
from PIL import Image,ImageDraw
from pyproj import Proj

def drawPolygon(geom, draw, w, h, minx, maxx, miny, maxy,proj):
    for j in range(0, geom.GetGeometryCount()):
        item = geom.GetGeometryRef(j)
        for i in range(0, item.GetPointCount()-2):
            p1 = item.GetPoint(i)
            p1=proj(p1[0],p1[1])
            p1=(w*(p1[0]-minx)/(maxx-minx),h-h*(p1[1]-miny)/(maxy-miny))
            p2 = item.GetPoint(i + 1)
            p2=proj(p2[0],p2[1])
            p2=(w*(p2[0]-minx)/(maxx-minx),h-h*(p2[1]-miny)/(maxy-miny))
            draw.line(p1 + p2, fill=128)
        p1 = item.GetPoint(item.GetPointCount()-1)
        p1=proj(p1[0],p1[1])
        p1=(w*(p1[0]-minx)/(maxx-minx),h-h*(p1[1]-miny)/(maxy-miny))
        p2 = item.GetPoint(0)
        p2=proj(p2[0],p2[1])
        p2=(w*(p2[0]-minx)/(maxx-minx),h-h*(p2[1]-miny)/(maxy-miny))
        draw.line(p1 + p2, fill=128)
    return

#set server info
hosti='localhost'
porti=5433
useri='postgres'
pwdi='postgres'
dbi='postgres'

# set the working directory
os.chdir('/home/myfile/CHN_adm')

#connect the server
conn = psycopg2.connect(host=hosti, port=porti, user=useri, password=pwdi,database=dbi)
cur = conn.cursor()

#draw shp on an image
#create the image
myproj=Proj('+proj=aea +lon_0=105 +lat_1=25 +lat_2=47 +ellps=krass')
cur.execute("SELECT ST_XMin(bbox.geom), ST_XMax(bbox.geom), ST_YMin(bbox.geom), ST_YMax(bbox.geom) FROM (SELECT ST_Envelope(ST_Union(geom)) AS geom FROM public.CHN_adm1) AS bbox")
bbox = cur.fetchone()
minlng = bbox[0]
maxlng = bbox[1]
minlat = bbox[2]
maxlat = bbox[3]
minx,miny=myproj(minlng,minlat)
maxx,maxy=myproj(maxlng,maxlat)

w = 1280
h = int(w * (maxy - miny) / (maxx- minx))
img = Image.new("RGB", (w, h), "white")
draw = ImageDraw.Draw(img)
#draw geometry
cur.execute('select gid, ST_AsText(geom) AS geom from public.CHN_adm1;')
layer=cur.fetchall()
for row in layer:
    ob = ogr.CreateGeometryFromWkt(row[1])
    gtype=ob.GetGeometryName()
    if gtype=='MULTIPOLYGON':
        for j in range(0, ob.GetGeometryCount()):
                item = ob.GetGeometryRef(j)
                drawPolygon(item, draw,w, h, minx, maxx, miny, maxy,myproj)
    else:
        drawPolygon(ob, draw,w, h, minx, maxx, miny, maxy,myproj)
#save image
img.save('/tmp/CHN1_aea_proj.jpg', 'JPEG')
print('Draw shp successfully!')
cur.close()
conn.close()




#if __name__=='__main__':


