# python 3.4.3
# -*- coding: utf-8 -*-

"""
Created on 03 17 2016
@author: wangyuxia
"""

from pyproj import Proj
import ogr
import sys
import psycopg2
import os.path
from PIL import Image,ImageDraw
sys.path.append("/home/wangyuxia/PycharmProjects/PyTest")

def drawPolygon(geom, draw, w, h, minlng, maxlng, minlat, maxlat):
    for j in range(0, geom.GetGeometryCount()):
        item = geom.GetGeometryRef(j)
        for i in range(0, item.GetPointCount()-2):
            p1 = item.GetPoint(i)
            # projection
            p1_lon,p1_lat = WebMercator(p1[0],p1[1])
            p1=(w*(p1_lon-minlng)/(maxlng-minlng),h-h*(p1_lat-minlat)/(maxlat-minlat))
            p2 = item.GetPoint(i + 1)
            # projection
            p2_lon,p2_lat = WebMercator(p2[0],p2[1])
            p2=(w*(p2_lon-minlng)/(maxlng-minlng),h-h*(p2_lat-minlat)/(maxlat-minlat))
            draw.line(p1 + p2, fill=128)
        p1 = item.GetPoint(item.GetPointCount()-1)
        # projection
        p1_lon,p1_lat = WebMercator(p1[0],p1[1])
        p1=(w*(p1_lon-minlng)/(maxlng-minlng),h-h*(p1_lat-minlat)/(maxlat-minlat))
        p2 = item.GetPoint(0)
        # projection
        p2_lon,p2_lat = WebMercator(p2[0],p2[1])
        p2=(w*(p2_lon-minlng)/(maxlng-minlng),h-h*(p2_lat-minlat)/(maxlat-minlat))
        draw.line(p1 + p2, fill=128)
    return


isn2004=Proj("+proj=lcc +lat_1=64.25 +lat_2=65.75 +lat_0=65 +lon_0=-19 +x_0=1700000 +y_0=300000 +no_defs +a=6378137 +rf=298.257222101 +to_meter=1")
wgs72be = Proj("+init=EPSG:3415") #South China Sea Lambert
wgs84=Proj("+init=EPSG:4326") # LatLon with WGS84 datum used by GPS units and Google Earth
UTM50N=Proj("+init=EPSG:32650") # UTM coords, zone 50N, WGS84 datum
WebMercator=Proj("+init=EPSG:3857") #WGS84 Web Mercator (Auxiliary Sphere)

conn = psycopg2.connect(database="postgres", user="postgres", password="123456", host="127.0.0.1", port="5432")
print("Opened database successfully")
cur = conn.cursor()
cur.execute("SELECT ST_XMin(bbox.geom),ST_XMax(bbox.geom),ST_YMin(bbox.geom),\
ST_YMax(bbox.geom) FROM (SELECT ST_Envelope(ST_Union(geom)) AS geom FROM china) AS bbox")
bbox = cur.fetchone()
minlng,minlat = WebMercator(bbox[0],bbox[2])
maxlng,maxlat = WebMercator(bbox[1],bbox[3])
w = 1280
h = int(w * (maxlat - minlat) / (maxlng - minlng))
img = Image.new("RGB", (w, h), "white")
draw = ImageDraw.Draw(img)
#draw geometry
cur.execute("select gid, name_1, name_2, ST_AsText(geom) AS geom from china ")
shp=cur.fetchall()
for row in shp:
    ob = ogr.CreateGeometryFromWkt(row[3])
    gtype=ob.GetGeometryName()
    if gtype=='MULTIPOLYGON':
        for j in range(0, ob.GetGeometryCount()):
                item = ob.GetGeometryRef(j)
                drawPolygon(item, draw,w, h, minlng, maxlng, minlat, maxlat)
    else:
        drawPolygon(ob, draw,w, h, minlng, maxlng, minlat, maxlat)
#save image
img.save('China_WebMercator.jpg', 'JPEG')
print('Draw shp successfully!')
cur.close()
conn.close()
